import java.lang.*;


/** history class, written by Dan Kiser, 1999
 *  <p>
 *  This class is used to store URLs that have been added
 *  to the history list.
 *
 */
public class history {

  private String  myURL;        // Encoded URL string
  private String  myData=null;  // Form data posted to the URL
  private boolean newURL=true;  // True if URL is new

  //*****************************************************************
  // Class constructor takes as input an encoded URL string.
  //
  public history(String url) {
    myURL  = url;
  }


  //*****************************************************************
  // Class constructor takes as input an encoded URL string and 
  // form data to be posted with this URL.
  //
  public history(String url, String data) {
    myURL  = url;
    myData = data;
  }


  //*****************************************************************
  // The isNew method is used to check if the URL was previously 
  // fetched.  Input a new value for the flag.
  //
  public boolean isNew(boolean flag) {
    boolean temp = newURL;
    newURL = flag;
    return temp;
  }


  //*****************************************************************
  // The hasData method is used to check if the URL has data to be
  // posted.
  //
  public boolean hasData() {
    return (myData != null);
  }


  //*****************************************************************
  // The getURL method is used to retrieve the encoded URL string.
  //
  public String getURL() {
    return myURL;
  }


  //*****************************************************************
  // The getData method is used to retrieve the form data.
  //
  public String getData() {
    return myData;
  }


} // history