import java.net.URL;
import java.net.MalformedURLException;
import java.lang.*;
import java.io.*;


/** loader class, written by Dan Kiser, 1999
 *  <p>
 *  This class is used to retrieve a document. The HTML is
 *  parsed to extract any secret links.  The secret links
 *  are stored in a vector created by the password class.
 *
 */
public class loader extends fetcher {


  //*****************************************************************
  // Class constructor takes as input a reference to the applet and
  // the encoded URL string.
  //
  public loader(password parent, String theURL) {

    super();

    app = parent;
    url = theURL;
    c5  = new cipher5(parent.hostIP);

  } // fetcher


  //*******************************************************
  // The run method is used to load the page.
  // 
  public void run() {

    URL theURL;

    StringBuffer sbUrl = c5.decode(url);

    if (app.debug) System.out.println("Decoded URL: " + sbUrl.toString());

    // Check to see if URL is absolute or relative.
    boolean isAbsolute = absolute(sbUrl);

    // Check to see if the user name should be appended
    // to the URL as a query string variable.
    if (app.query) sbUrl = addUser(sbUrl);

    try {
      if (!isAbsolute) {
        theURL = new URL(app.getDocumentBase(), sbUrl.toString());
      }
      else {
        theURL = new URL(sbUrl.toString());
      }

      if (app.debug) System.out.println("Absolute URL: "+theURL);

      try {
        DataInputStream theHTML = new DataInputStream(theURL.openStream());

        if (app.base) {
          int i = theURL.toString().lastIndexOf('/');

          String base = theURL.toString().substring(0,i+1);
          if (app.debug) System.out.println("Base=" + base);

          app.content.append("<BASE HREF=\"" + base + "\">\n");
        }

        // Remove all elements in vector of urls
        if(!app.urls.isEmpty()) app.urls.removeAllElements();

        if (app.debug) System.out.println("Reading HTML input stream ...");

        while (true) {
          char thisChar = (char) theHTML.readByte();
          if (thisChar == '<') {
            StringBuffer tag1 = readTag(theHTML);
            String tag2 = checkTag(tag1);
            app.content.append(tag2);
          }
          else {
            app.content.append(thisChar);
          }

        } // while 

      }
      catch (EOFException e) {  
        // This page is done
        if (app.debug) System.out.println("Done loading "+app.content.length()+" bytes.");

      }   
      catch (Exception e) {
        System.err.println(e); 
        app.content.append("<h3>Error Opening Input Stream</h3><br>" + e);
      }

    }
    catch (MalformedURLException e) { 
      System.err.println(e);
      app.content.append("<h3>Invalid URL</h3><br>" + e);
    }

    sbUrl.setLength(0);

  } // run

} // loader
