import java.net.URL;
import java.net.URLEncoder;
import java.net.URLConnection;
import java.net.MalformedURLException;
import java.util.StringTokenizer;
import java.util.NoSuchElementException;
import java.lang.*;
import java.io.*;


/** poster class, written by Dan Kiser, 1999
 *  <p>
 *  This class is used to post form data. The form response
 *  is parsed to extract any secret links.  The secret links
 *  are stored in a vector created by the password class.
 *
 */
public class poster extends fetcher {

  private String qry;   // Holds form data to be posted

  //*****************************************************************
  // Class constructor takes as input a reference to the applet and
  // the encoded URL string.
  //
  public poster(password parent, String theURL, String data) {

    super();

    app = parent;
    url = theURL;
    qry = data;
    c5  = new cipher5(parent.hostIP);

  } // fetcher


  //*******************************************************
  // The run method is used to load the page.
  // 
  public void run() {

    URL theURL;

    StringBuffer sbUrl = c5.decode(url);

    if (app.debug) System.out.println("Decoded URL: " + sbUrl.toString());

    // Check to see if URL is absolute or relative.
    boolean isAbsolute = absolute(sbUrl);

    // Check to see if the user name should be appended
    // to the URL as a query string variable.
    if (app.query) sbUrl = addUser(sbUrl);

    // Print all name/value pairs.
    if (app.debug) {
      StringTokenizer st = new StringTokenizer(qry,"&");
      while (st.hasMoreTokens()) {
        String var = st.nextToken();
        System.out.println("Data: " + var);
      }
    }

    try {
      if (!isAbsolute) {
        theURL = new URL(app.getDocumentBase(), sbUrl.toString());
      }
      else {
        theURL = new URL(sbUrl.toString());
      }

      if (app.debug) System.out.println("Absolute URL: "+theURL);

      try {
        // Open the connection and prepare to post.

        URLConnection uc = theURL.openConnection();

        uc.setDoOutput(true);
        uc.setDoInput(true);
        uc.setAllowUserInteraction(false);
        uc.setUseCaches(false);
        uc.setRequestProperty("Content-Type","application/x-www-form-urlencoded");

        DataOutputStream dos = new DataOutputStream(uc.getOutputStream());

        // The POST line, the Accept line, and the content-type
        // headers are sent by the URLConnection.
        // We just need to send the data.
        dos.writeBytes(qry);
        dos.flush();
        dos.close();

        // Read the response
        DataInputStream dis = new DataInputStream(uc.getInputStream());

        if (app.base) {
          int i = theURL.toString().lastIndexOf('/');

          String base = theURL.toString().substring(0,i+1);
          if (app.debug) System.out.println("Base=" + base);

          app.content.append("<BASE HREF=\"" + base + "\">\n");
        }

        // Remove all elements in vector of urls
        if(!app.urls.isEmpty()) app.urls.removeAllElements();

        if (app.debug) System.out.println("Reading POST response ...");

        while (true) {
          char thisChar = (char) dis.readByte();
          if (thisChar == '<') {
            StringBuffer tag1 = readTag(dis);
            String tag2 = checkTag(tag1);
            app.content.append(tag2);
          }
          else {
            app.content.append(thisChar);
          }

        } // while 

      }
      catch (EOFException e) {  
        // This page is done
        if (app.debug) System.out.println("Done loading "+app.content.length()+" bytes.");

      }   
      catch (Exception e) {
        System.err.println(e); 
        app.content.append("<h3>Error Opening Input Stream</h3><br>" + e);
      }

    }
    catch (MalformedURLException e) { 
      System.err.println(e);
      app.content.append("<h3>Invalid URL</h3><br>" + e);
    }

    sbUrl.setLength(0);

  } // run

} // loader
