import java.net.URL;
import java.net.MalformedURLException;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.io.*;
import java.applet.Applet;


/** Set Password applet, written by Dan Kiser, 1999
 *  <p>
 *  This applet is used to generate encrypted
 *  password vaules.
 *
 *  <p>
 *  The applet accepts the following parameter values: 
 *  (all parameters are optional)
 *  <ul>
 *  <li>param name=psw_url value="url"       <br>
 *      where url is the password file url
 *  </ul>
 *
 */
public class setpass extends Applet implements ActionListener, KeyListener {

  protected TextField name;         // Username field
  protected TextField psw;          // Password field
  protected TextField surl;         // Starting URL field
  protected Hashtable hash = new Hashtable(13);;  // Hash table used to hold database
  protected URL pswURL=null;        // Password database URL

  private cipher5 c5;  // Cipher5 object

  public void init()
  {
    String attr;

    c5 = new cipher5(this);
 
    c5.printIP();

    // Get password file URL
    attr = getParameter("psw_url");
    if (attr != null) {
      try {
        // Relative URLs don't have colons.
        if (attr.indexOf(":") == -1) {
          pswURL = new URL(this.getDocumentBase(), attr);
        }
        else {
          pswURL = new URL(attr);
        }
      }
      catch (Exception e) { System.err.println(e); }
    }

    if (pswURL == null) {
      try {
        // Default to users.txt in document base directory
        pswURL = new URL(this.getDocumentBase(),"./users.txt"); 
      }
      catch (Exception e) { System.err.println(e); }
    }      

    // Set background color
    attr = getParameter("bgcolor");
    int bgcolor;
    try {
      bgcolor = (attr == null) ? Color.white.getRGB() : (Integer.parseInt(attr,16));
    }
    catch (Exception e) { bgcolor = Color.white.getRGB(); }
    setBackground(new Color(bgcolor));

    // Set font
    setFont(new Font("SansSerif", Font.PLAIN, 14));

    // Set layout
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints constraints = new GridBagConstraints();
    setLayout(gridbag);    

    // Name label
    constraints.fill = GridBagConstraints.NONE;
    constraints.anchor = GridBagConstraints.EAST;
    buildConstraints(constraints, 0, 0, 1, 1, 10, 40);
    Label label1 = new Label("Username:", Label.LEFT);
    gridbag.setConstraints(label1, constraints);
    add(label1);

    // Name text field
    constraints.fill = GridBagConstraints.HORIZONTAL;
    buildConstraints(constraints, 1, 0, 1, 1, 90, 0);
    name = new TextField();
    gridbag.setConstraints(name, constraints);
    name.addKeyListener(this);
    add(name);

    // Password label
    constraints.fill = GridBagConstraints.NONE;
    constraints.anchor = GridBagConstraints.EAST;
    buildConstraints(constraints, 0, 1, 1, 1, 0, 40);
    Label label2 = new Label("Password:", Label.LEFT);
    gridbag.setConstraints(label2, constraints);
    add(label2);

    // Password text field
    constraints.fill = GridBagConstraints.HORIZONTAL;
    buildConstraints(constraints, 1, 1, 1, 1, 0, 0);
    psw = new TextField();
//    psw.setEchoChar('*');
    gridbag.setConstraints(psw, constraints);
    psw.addKeyListener(this);
    add(psw);

    // URL label
    constraints.fill = GridBagConstraints.NONE;
    constraints.anchor = GridBagConstraints.EAST;
    buildConstraints(constraints, 0, 2, 1, 1, 0, 40);
    Label label3 = new Label("Start URL:", Label.LEFT);
    gridbag.setConstraints(label3, constraints);
    add(label3);

    // URL text field
    constraints.fill = GridBagConstraints.HORIZONTAL;
    buildConstraints(constraints, 1, 2, 1, 1, 0, 0);
    surl = new TextField();
    gridbag.setConstraints(surl, constraints);
    surl.addKeyListener(this);
    surl.setName("surl");
    add(surl);

    // Button Panel
    constraints.fill = GridBagConstraints.NONE;
    constraints.anchor = GridBagConstraints.CENTER;
    buildConstraints(constraints, 0, 3, 2, 1, 0, 20);
    Panel panel = new Panel();

    // Set panel layout
    panel.setLayout(new GridLayout(1, 2, 20, 2));
    gridbag.setConstraints(panel, constraints);
    add(panel);

    // Login button
    Button login = new Button("Add");
    login.addActionListener(this);
    login.addKeyListener(this);
    panel.add(login);

    // Clear button
    Button clear = new Button("Clear");
    clear.addActionListener(this);
    clear.addKeyListener(this);
    panel.add(clear);

    setSize(250,150);

  } // init


  public void start() {

    if (pswURL != null) getUsers();

    name.setText("");
    psw.setText("");
    surl.setText("");

    name.requestFocus();

  } // start


  void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh, int wx, int wy)
  {
    gbc.gridx = gx;
    gbc.gridy = gy;
    gbc.gridwidth = gw;
    gbc.gridheight = gh;
    gbc.weightx = wx;
    gbc.weighty = wy;
    gbc.ipadx = 0;
    gbc.ipady = 0;

  } // buildConstraints


  public Insets getInsets() {
    return new Insets(5, 5, 5, 5);
  }


  //*******************************************************
  // The following methods are used to listen for key press 
  // events in the text fields.  It will allow ony letters
  // and digits to be entered.
  // 
  public void keyTyped(KeyEvent e) {
    return;  
  }

  public void keyPressed(KeyEvent e) {

//    System.out.println("Key Press="+e.getKeyCode());

    if (!Character.isLetterOrDigit(e.getKeyChar()) && 
        e.getComponent().getName() != "surl"   &&
        e.getKeyCode() != KeyEvent.VK_ENTER  &&
        e.getKeyCode() != KeyEvent.VK_SHIFT  &&
        e.getKeyCode() != KeyEvent.VK_LEFT   &&
        e.getKeyCode() != KeyEvent.VK_RIGHT  &&
        e.getKeyCode() != KeyEvent.VK_DELETE &&
        e.getKeyCode() != KeyEvent.VK_TAB    &&
        e.getKeyCode() != KeyEvent.VK_BACK_SPACE) {
        e.consume();
    }

  }

  public void keyReleased(KeyEvent e) {

    if (e.getSource() instanceof Button) {

      Button theSource = (Button) e.getSource();

//      System.out.println("Command="+theSource.getActionCommand());
//      System.out.println("If "+e.getKeyCode()+"="+KeyEvent.VK_ENTER);

      // Dispatch a new action event so that the ENTER key
      // behaves like a mouse click.
      if (e.getKeyCode() == KeyEvent.VK_ENTER) {
        e.consume();
        ActionEvent ae = new ActionEvent(e.getSource(),ActionEvent.ACTION_PERFORMED,theSource.getActionCommand());
        theSource.dispatchEvent(ae);
      }

    }
    else {

      TextField theSource = (TextField) e.getSource();

//      System.out.println("Key Press="+e.getKeyCode());

      if (e.getKeyCode() == KeyEvent.VK_ENTER)
        theSource.transferFocus();
    }

  }


  //*******************************************************
  // The following methods are used to listen for events 
  // occurring on the buttons in this layout.  
  // 

  // Validate a username or a password.
  boolean isValid(String text, int minLen, int minDigits) {

    StringBuffer sb = new StringBuffer(text);

    int digits=0;
    int i=0;

    // Count letters and digits
    for(; i < sb.length(); i++) {
      if (Character.isDigit(sb.charAt(i))) {
        digits++;
      }
    }

    return ( (i >= minLen && digits >= minDigits) ? true : false );

  } // isValid


  public void actionPerformed(java.awt.event.ActionEvent ae) {

//    System.out.println("Action Performed");
//    System.out.println("Command="+ae.getActionCommand());

    msgbox msg;

    Button theSource = (Button) ae.getSource();

    Frame theFrame = msgbox.getFrame(this);

    if (theSource.getLabel().equals("Add")) {
      // handle add user

      if (isValid(name.getText(),2,0)) {

        if (!hash.containsKey(name.getText())) {

          if (isValid(psw.getText(),6,1)) {

            if (surl.getText().length() > 4) {

              String ipNum = c5.getIP();

              if (ipNum.equals("0000")) {
                msg = new msgbox(theFrame, "Warning", "A valid IP address was not found. You should load this applet from the server where your protected documents reside.");
              }

              String user = name.getText();
              String pswd = psw.getText();
              String curl = surl.getText();

              // Crypt password - break into 8 byte strings
              String pass = new String();
              int i = 0;

              while (pswd.length()-i > 8) {
                pass += jcrypt.crypt(user,pswd.substring(i,i+8));
                i += 8;
              }

              pass += jcrypt.crypt(user,pswd.substring(i));

              // Encode start URL with password & IP as key
              String link = c5.encode(curl, pswd);

              // Encode start URL with host IP address
              link = c5.decodeHex(link).toString();
              link = c5.encode(link, c5.getIP());

              String buff = pass + "  " + link;

              hash.put(user,buff);
        
              name.setText("");
              name.requestFocus();
              psw.setText("");
              surl.setText("");

            }
            else {
              msg = new msgbox(theFrame, "Error", "Start URL must contain at least 5 characters. Please try again.");
              surl.requestFocus();
            }
          }
          else {
            msg = new msgbox(theFrame, "Error", "The password must contain at least 5 upper/lower case letters plus 1 digit. Please try again.");
            psw.requestFocus();
          }
        }
        else {
          msg = new msgbox(theFrame, "Error", "Duplicate user name found in the database. Please try again.");
          name.requestFocus();
        }
      }
      else {
        msg = new msgbox(theFrame, "Error", "The user name must contain at least 2 letters/digits. Please try again.");
        name.requestFocus();
      }

    } else if (theSource.getLabel().equals("Clear")) {
      // handle clear
      name.setText("");
      name.requestFocus();
      psw.setText("");
    }
  }


  //*******************************************************
  // This method is used to load the list of valid user
  // names and passwords into a hash table.
  // 
  void getUsers() {

    boolean ready = false;
    int tries = 0;

    Frame theFrame = msgbox.getFrame(this);

    try {

      BufferedReader in = new BufferedReader(new InputStreamReader(pswURL.openStream()));

      String inputLine;

      while (tries < 2 && !ready) {
        if (in.ready()) {
          ready = true;
          System.out.println("Begin loading user database ...");

          while ((inputLine = in.readLine()) != null) {
            int i = inputLine.indexOf(' ');
            String username = inputLine.substring(0,i);
            do { i++; } while (Character.isWhitespace(inputLine.charAt(i)));
            String password = inputLine.substring(i);

            hash.put(username,password);
            System.out.println("username = "+username+"  password = "+password);
          }

          System.out.println("Done loading user database ...");
        }
        else {
          System.out.println("Input stream was not ready ...");
          msgbox msg = new msgbox(theFrame, "Warning", "Database input stream was not ready.");
          tries++;
        }
      }
      in.close();
    }
    catch (Exception e) { 
      System.err.println(e); 
    }

  } // getUsers


  //*******************************************************
  // This method is used by JavaScript to retrieve the
  // list of passwords for display in a form textarea 
  // field.
  //
  public synchronized String getList() {

    String list = new String();

    System.out.println("Password database requested ...");

    Enumeration keys = hash.keys(); 

    System.out.println("Record count = " + hash.size());

    while (keys.hasMoreElements()) {
      String username = (String)keys.nextElement();
      String password = (String)hash.get(username);
      list = list + username + "  " + password + "\n";
      System.out.println("username = "+username+"  password = "+password);
    }

    return list;

  } // getList

 
} // setpass